# Overview of GitLab CI/CD
# https://docs.gitlab.com/ee/ci/README.html

# Config reference for this file
# https://docs.gitlab.com/ee/ci/yaml/README.html

stages:
  - build
  - test
  - deploy

### BUILD #####################################################################

build:centos6:
  stage: build
  tags:
    - centos6
    - opencpi
    - shell
  artifacts:
    paths:
      - dist/some-file.txt
  script:
    - mkdir -p dist
    - echo '[c6] Hello, World!' > dist/some-file.txt

build:centos7:
  stage: build
  tags:
    - centos7
    - opencpi
    - shell
  artifacts:
    paths:
      - dist/some-file.txt
  script:
    - mkdir -p dist
    - echo '[c7] Hello, World!' > dist/some-file.txt

### TEST ######################################################################

test:centos6:
  stage: test
  tags:
    - centos6
    - opencpi
    - shell
  dependencies: ['build:centos6']
  artifacts:
    paths:
      - dist.tgz
  script:
    - test "$(< dist/some-file.txt)" = '[c6] Hello, World!'
    - tar czf dist.tgz dist

test:centos7:
  stage: test
  tags:
    - centos7
    - opencpi
    - shell
  dependencies: ['build:centos7']
  artifacts:
    paths:
      - dist.tgz
  script:
    - test "$(< dist/some-file.txt)" = '[c7] Hello, World!'
    - tar czf dist.tgz dist

### DEPLOY ####################################################################

deploy:centos6:
  stage: deploy
  tags:
    - centos6
    - opencpi
    - shell
  dependencies: ['test:centos6']
  script:
    - test -f dist.tgz
    - echo 'Uploading dist.tgz to some location...'

deploy:centos7:
  stage: deploy
  tags:
    - centos7
    - opencpi
    - shell
  dependencies: ['test:centos7']
  script:
    - test -f dist.tgz
    - echo 'Uploading dist.tgz to some location...'

